import pymysql
import re
from concurrent.futures import ThreadPoolExecutor
class getoutofloop(Exception): pass
import datetime
import itertools
import os
from collections import defaultdict
import requests
from requests.exceptions import RequestException
from DBUtils.PooledDB import PooledDB
from threading import RLock
LOCK = RLock()

POOL_validity = PooledDB(
    creator=pymysql,  # 使用链接数据库的模块
    maxconnections=None,  # 连接池允许的最大连接数，0和None表示没有限制
    mincached=10,  # 初始化时，连接池至少创建的空闲的连接，0表示不创建
    maxcached=0,  # 连接池空闲的最多连接数，0和None表示没有限制
    maxshared=0,
    # 连接池中最多共享的连接数量，0和None表示全部共享，ps:其实并没有什么用，因为pymsql和MySQLDB等模块中的threadsafety都为1，所有值无论设置多少，_maxcahed永远为0，所以永远是所有链接共享
    blocking=True,  # 链接池中如果没有可用共享连接后，是否阻塞等待，True表示等待，False表示不等待然后报错
    setsession=[],  # 开始会话前执行的命令列表
    ping=0,  # ping Mysql 服务端，检查服务是否可用
    host='rm-j6cgph88etye1rs2xyo.mysql.rds.aliyuncs.com',
    port=3306,
    user='pypi',
    password='Aa12212748',
    database='pypi_validity_evaluation',
    charset='utf8'
 )

# POOL_validity = PooledDB(
#      creator = pymysql, #使用链接数据库的模块
#      maxconnections = None,  #连接池允许的最大连接数，0和None表示没有限制
#      mincached = 10, #初始化时，连接池至少创建的空闲的连接，0表示不创建
#      maxcached = 0, #连接池空闲的最多连接数，0和None表示没有限制
#      maxshared = 0, #连接池中最多共享的连接数量，0和None表示全部共享，ps:其实并没有什么用，因为pymsql和MySQLDB等模块中的threadsafety都为1，所有值无论设置多少，_maxcahed永远为0，所以永远是所有链接共享
#      blocking = True, #链接池中如果没有可用共享连接后，是否阻塞等待，True表示等待，False表示不等待然后报错
#      setsession = [],#开始会话前执行的命令列表
#      ping = 0,#ping Mysql 服务端，检查服务是否可用
#      host = '219.216.64.249',
#      port = 3306,
#      user = 'pypi',
#      password = 'Aa12212748',
#      database = 'pypi_validity_evaluation',
#      charset = 'utf8'
#  )

def single_detect_conflict(filename,fileversion,update_time):

    if fileversion is None:
        fileversion=""
    list1 = []
    list1.append(filename)
    list1.append(fileversion)
    list1.append("")
    global check_list
    check_list = []
    check_list.append(list1)
    check_requirement(check_list,0,update_time)
    # print(check_list)
    requirement_list=[]
    requirement_list=circle_requirement(filename, fileversion,"",0,check_list,update_time)
    range_list = []
    priority_list = []
    node_list = []
    detect_confilct_status = 0
    if requirement_list is not None  and requirement_list!=[]:
        # print("start detect conflict: ", filename,fileversion, "update_time:",update_time)
        (range_list,priority_list,node_list)=printlist(requirement_list,range_list,priority_list, node_list)
        # print("range_list:", len(range_list))
        # print("priority_list:", len(priority_list))
        # print("node_list:", len(node_list))
        (detect_confilct_status,confilct_node)=find_confilct(priority_list,range_list,node_list,filename,fileversion,update_time)
    return detect_confilct_status


def single_detect_conflict_return_node(filename,fileversion,update_time):

    if fileversion is None:
        fileversion=""
    list1 = []
    list1.append(filename)
    list1.append(fileversion)
    list1.append("")
    global check_list
    check_list = []
    check_list.append(list1)
    check_requirement(check_list,0,update_time)
    # print(check_list)
    requirement_list=[]
    requirement_list=circle_requirement(filename, fileversion,"",0,check_list,update_time)
    range_list = []
    priority_list = []
    node_list = []
    detect_confilct_status = 0
    if requirement_list is not None  and requirement_list!=[]:
        print("start detect conflict: ", filename,fileversion)

        (range_list,priority_list,node_list)=printlist(requirement_list,range_list,priority_list,node_list)
        (detect_confilct_status,confilct_node)=find_confilct(priority_list,range_list,node_list,filename,fileversion,update_time)
    return confilct_node

def printlist(r_list,range_list,priority_list,node_list):
    if r_list is not None:
        for i in r_list:
            if isinstance(i,str):
                str_num = i.split('@')[-1]
                pos = i.rfind("@")
                text = i[:pos]
                num = int(str_num)
                if num != 1:
                    pattern_second = re.search('&(.*?)!version range:(.*?)!', text, re.S)
                    node_name = pattern_second.group(1)
                    version_range = pattern_second.group(2)
                    range_list.append(str(version_range))
                    priority_list.append(num)
                    node_list.append(node_name)
            else:
                printlist(i,range_list,priority_list,node_list)
    return range_list,priority_list,node_list

def circle_requirement(package_name,package_version,version_range,num,check_list,update_time):
    if num>=3:
        return
    num=num+1
    templist=[]
    package_info = "&"+package_name + "!version range:" + version_range + "!"+"@"+str(num)
    templist.append(package_info)
    temp_requirementlist = []
    datalist = get_requirement(package_name,package_version)
    if datalist != []:
        for p in datalist:
            # temp_data=p[0]+"/version range:"+p[2]
            # package_info = p[0] + "<version range:" + p[2] + ">"
            # templist.append(package_info)
            # print("requirementname:",p[0],"requirementversion:",p[1])

            requirement = p[0]
            requirement_version = p[1]
            requirement_version_status = p[2]
            version_range = p[3]
            true_verion = ""

            if p[2] == 1 or p[2] == "1":
                true_verion=p[1]
            elif p[2] == 2 or p[2] == "2":
                try:
                    for temp_check in check_list:
                        if temp_check[0] == requirement:
                            if requirement_version == find_newestversion(requirement_version, temp_check[1]):
                                true_verion = temp_check[1]
                            else:
                                true_verion = find_elder_version_updatetime(requirement, requirement_version,update_time)
                            raise getoutofloop()
                except getoutofloop:
                    pass
                if true_verion == "":
                    true_verion = find_elder_version_updatetime(requirement, requirement_version, update_time)
            elif p[2] == 0 or p[2] == "0":

                try:
                    for temp_check in check_list:
                        # print("requirement:",requirement)
                        # print("temp_check:",temp_check)
                        if temp_check[0] == requirement:
                            true_verion = temp_check[1]
                            raise getoutofloop()
                except getoutofloop:
                    pass
                if true_verion == "":
                    true_verion = find_fileversion_updatetime(requirement, update_time)

            temp_requirementlist.append(circle_requirement(p[0],true_verion,p[3],num,check_list,update_time))
    templist.append(temp_requirementlist)
    return templist

def get_requirement(package_name,package_version):
    with LOCK:
        sql2 = "select DISTINCT requirement,requirement_version,requirement_version_status,version_range from package_info where  package_name='%s' and package_version='%s'" % (package_name,package_version)
        get_requirement_datas=[]
        try:
            package_info_conn = POOL_validity.connection()
            package_info_cursor = package_info_conn.cursor()
            package_info_cursor.execute(sql2)
            get_requirement_datas = package_info_cursor.fetchall()
        except Exception as e:
            print("package_info db error",e)
        finally:
            package_info_conn.close()

    datalist=[]
    for u in get_requirement_datas:
        datalist.append(list(u))

    return datalist

def check_requirement(check_list,num,update_time):
    # print("check_list:", check_list)
    # print("num:", num)
    if num>=4:
        return
    if check_list!=[] and len(check_list)>num:
        temp_nodelist=[]
        temp_nodelist=check_list[num]
        if temp_nodelist !=[]:
            package_name=temp_nodelist[0]
            package_version = temp_nodelist[1]
            version_range = temp_nodelist[2]
            datalist = get_requirement(package_name, package_version)
            if datalist != []:
                for p in datalist:
                    requirement=p[0]
                    requirement_version=p[1]
                    requirement_version_status=p[2]
                    version_range=p[3]
                    true_verion=""
                    if requirement_version_status == 1 or requirement_version_status == "1":
                        true_verion = p[1]
                    elif requirement_version_status == 2 or requirement_version_status == "2":
                        try:
                            for temp_check in check_list:
                                if temp_check[0]==requirement:
                                    if requirement_version==find_newestversion(requirement_version,temp_check[1]):
                                        true_verion=temp_check[1]
                                    else:
                                        true_verion=find_elder_version_updatetime(requirement,requirement_version,update_time)
                                    raise getoutofloop()
                        except getoutofloop:
                            pass
                        if true_verion=="":
                            true_verion=find_elder_version_updatetime(requirement,requirement_version,update_time)
                    elif requirement_version_status == 0 or requirement_version_status == "0":
                        try:
                            for temp_check in check_list:
                                # print("requirement:",requirement)
                                # print("temp_check:",temp_check)
                                if temp_check[0]==requirement:
                                    true_verion=temp_check[1]
                                    raise getoutofloop()
                        except getoutofloop:
                            pass
                        if true_verion == "":
                            true_verion = find_fileversion_updatetime(requirement,update_time)

                    t_list=[]
                    t_list.append(requirement)
                    t_list.append(true_verion)
                    t_list.append(version_range)
                    check_list.append(t_list)
        check_requirement(check_list,num+1,update_time)
    # else:
        # print("check_list",check_list)
        # return check_list

def add_version_range(version_lower,version_uper,status):
    version_range=[]
    temp_list_low = []
    temp_list_up = []
    temp_list_low.append(version_lower)
    temp_list_up.append(version_uper)
    if status=="openclosed":
        temp_list_low.append("open")
        temp_list_up.append("closed")
    if status == "closed":
        temp_list_low.append("closed")
        temp_list_up.append("closed")
    if status=="closedopen":
        temp_list_low.append("closed")
        temp_list_up.append("open")
    if status=="open":
        temp_list_low.append("open")
        temp_list_up.append("open")
    version_range.append(temp_list_low)
    version_range.append(temp_list_up)

    return version_range

def find_confilct(priority_list,range_list,node_list,first_node_name,fileversion,update_time):

    confilct_node=""
    confilct_status=0
    zoom_list = []
    version_range_num_list = []
    version_range_limit_list = []
    j = 0
    list_num = len(range_list)
    # print("**************************************")
    # print("priority_list:", priority_list)
    # print("range_list:", range_list)
    # print("node_list:", node_list)
    # print("**************************************")
    max_version="9999999999999"

    # 范围变成集合形式
    for r in range(len(range_list)):
        if range_list[r] is None or range_list[r] == "":
            # print('name')
            range_list[r] = "<=" + max_version
        # print("r:",r)
    for r in range(len(range_list)):
        version_range = re.split(',', range_list[r], re.S)
        #print("version_range:", version_range)
        if len(version_range) == 1:
            version_range_num = re.findall(r'[a-zA-Z0-9.]', str(version_range[0]), re.S)
            version_range_num = "".join(version_range_num)
            version_range = str(version_range)
            # print("version_range:", version_range)
            # if '=' or '=='in r:
            #     print('www')
            #     # zoom_list[j] = version_range_num
            if "<=" in version_range:
                zoom_list.append(add_version_range('0.0.0.0.0.0', version_range_num,"closed"))
                # zoom_list.append(I.openclosed('0.0.0.0.0.0', version_range_num))
            elif "<" in version_range and "<=" not in version_range:
                # print(version_range,"aaa",version_range_num)
                zoom_list.append(add_version_range('0.0.0.0.0.0', version_range_num, "closedopen"))
                # zoom_list.append(I.open('0.0.0.0.0.0', version_range_num))
            elif ">=" in version_range:
                zoom_list.append(add_version_range(version_range_num, max_version, "closed"))
                # zoom_list.append(I.closed(version_range_num,str(getfileversion.fileversion(node_list[r]))))
            elif ">" in version_range and ">=" not in version_range:
                zoom_list.append(add_version_range(version_range_num, max_version, "openclosed"))
                # zoom_list.append(I.openclosed(version_range_num,str(getfileversion.fileversion(node_list[r]))))
            elif "=" or "=="in version_range:
                zoom_list.append(add_version_range(version_range_num, version_range_num, "closed"))
                # zoom_list.append(I.closed(version_range_num, version_range_num))
        elif len(version_range) == 2:
            i = 0
            for v in version_range:
                version_range_num = re.findall(r'[a-zA-Z0-9.]', str(v), re.S)
                version_range_limit = re.findall(r'[^a-zA-Z0-9.]', str(v), re.S)
                version_range_num = "".join(version_range_num)
                version_range_limit = "".join(version_range_limit)

                version_range_num_list.append(version_range_num)
                version_range_limit_list.append(version_range_limit)
            l1 = version_range_num_list[0].split('.')
            l2 = version_range_num_list[1].split('.')
            strl1=''
            strl2=''
            for ml1 in range(len(l1)):
                if l1[ml1]=="" or l1[ml1] is None:
                    version_range_num_list[0].split('.')[ml1]='0'
                    l1[ml1]='0'
                if ml1!=0:
                    strl1=strl1+'.'+l1[ml1]
                else:
                    strl1=l1[ml1]
            for nl2 in range(len(l2)):
                if l2[nl2]=="" or l2[nl2] is None:
                    version_range_num_list[1].split('.')[nl2]='0'
                    l2[nl2]='0'
                if nl2!=0:
                    strl2 = strl2 + '.'+ l2[nl2]
                else:
                    strl2=l2[nl2]

            version_range_num_list[0]=strl1
            version_range_num_list[1]=strl2
            # for l2_s in l2:
            #     # print("l2s:", l2_s)
            #     if l2_s=="" or l2_s is None:
            #         l2_s=0
            if len(l1) <= len(l2):
                # print("length1",len(version_range_num_list[0].split('.')))
                length = len(l1)
            else:
                # print("length2", len(version_range_num_list[0].split('.')))
                length = len(l2)
            try:
                for m in range(length):
                    # 补0
                    if len(l1[m]) > len(l2[m]):
                        i = len(l1[m]) - len(l2[m])
                        for e in range(i):
                            l2[m] = "0" + l2[m]
                        if l1[m] > l2[m]:
                            top = version_range_num_list[0]
                            low = version_range_num_list[1]
                            if "<=" in version_range_limit_list[0] and ">=" in version_range_limit_list[1]:
                                zoom_list.append(add_version_range(low, top, "closed"))
                                # zoom_list.append(I.closed(low, top))
                            elif "<=" in version_range_limit_list[0] and ">" in version_range_limit_list[1] and ">="  not in version_range_limit_list[1] :
                                zoom_list.append(add_version_range(low, top, "openclosed"))
                                # zoom_list.append(I.openclosed(low, top))
                            elif "<" in version_range_limit_list[0] and ">=" in version_range_limit_list[1] and "<="  not in version_range_limit_list[0]:
                                zoom_list.append(add_version_range(low, top, "closedopen"))
                                # zoom_list.append(I.closedopen(low, top))
                            elif "<" in version_range_limit_list[0] and ">" in version_range_limit_list[1]:
                                zoom_list.append(add_version_range(low, top, "open"))
                                # zoom_list.append(I.open(low, top))
                            raise getoutofloop()
                    elif len(l1[m]) < len(l2[m]):
                        i = len(l2[m]) - len(l1[m])
                        for e in range(i):
                            l1[m] = "0" + l1[m]
                        if l1[m] < l2[m]:
                            top = version_range_num_list[1]
                            low = version_range_num_list[0]
                            if "<=" in version_range_limit_list[1] and ">=" in version_range_limit_list[0]:
                                zoom_list.append(add_version_range(low, top, "closed"))
                                # zoom_list.append(I.closed(low, top))
                            elif "<=" in version_range_limit_list[1] and ">" in version_range_limit_list[0] and ">="  not in version_range_limit_list[0]:
                                zoom_list.append(add_version_range(low, top, "openclosed"))
                                # zoom_list.append(I.openclosed(low, top))
                            elif "<" in version_range_limit_list[1] and ">=" in version_range_limit_list[0] and "<=" not in version_range_limit_list[1]:
                                zoom_list.append(add_version_range(low, top, "closedopen"))
                                # zoom_list.append(I.closedopen(low, top))
                            elif "<" in version_range_limit_list[1] and ">" in version_range_limit_list[0]:
                                zoom_list.append(add_version_range(low, top, "open"))
                                # zoom_list.append(I.open(low, top))
                            raise getoutofloop()
                    elif len(l1[m]) == len(l2[m]):
                        if l1[m] > l2[m]:
                            top = version_range_num_list[0]
                            low = version_range_num_list[1]
                            if "<=" in version_range_limit_list[0] and ">=" in version_range_limit_list[1]:
                                zoom_list.append(add_version_range(low, top, "closed"))
                                # zoom_list.append(I.closed(low, top))
                            elif "<=" in version_range_limit_list[0] and ">" in version_range_limit_list[1] and ">="  not in version_range_limit_list[1] :
                                zoom_list.append(add_version_range(low, top, "openclosed"))
                                # zoom_list.append(I.openclosed(low, top))
                            elif "<" in version_range_limit_list[0] and ">=" in version_range_limit_list[1] and "<="  not in version_range_limit_list[0]:
                                zoom_list.append(add_version_range(low, top, "closedopen"))
                                # zoom_list.append(I.closedopen(low, top))
                            elif "<" in version_range_limit_list[0] and ">" in version_range_limit_list[1]:
                                zoom_list.append(add_version_range(low, top, "open"))
                                # zoom_list.append(I.open(low, top))
                            raise getoutofloop()
                        elif l1[m] < l2[m]:
                            top = version_range_num_list[1]
                            low = version_range_num_list[0]
                            if "<=" in version_range_limit_list[1] and ">=" in version_range_limit_list[0]:
                                zoom_list.append(add_version_range(low, top, "closed"))
                                # zoom_list.append(I.closed(low, top))
                            elif "<=" in version_range_limit_list[1] and ">" in version_range_limit_list[0] and ">="  not in version_range_limit_list[0]:
                                zoom_list.append(add_version_range(low, top, "openclosed"))
                                # zoom_list.append(I.openclosed(low, top))
                            elif "<" in version_range_limit_list[1] and ">=" in version_range_limit_list[0] and "<=" not in version_range_limit_list[1]:
                                zoom_list.append(add_version_range(low, top, "closedopen"))
                                # zoom_list.append(I.closedopen(low, top))
                            elif "<" in version_range_limit_list[1] and ">" in version_range_limit_list[0]:
                                zoom_list.append(add_version_range(low, top, "open"))
                                # zoom_list.append(I.open(low, top))
                            raise getoutofloop()
            except getoutofloop:
                pass
            version_range_num_list = []
            version_range_limit_list = []

    dd = defaultdict(list)
    for k, va in [(v, i) for i, v in enumerate(node_list)]:
        dd[k].append(va)
    dd = list(dd.items())
    # print("dd",dd)
    # print('range_list',len(range_list))
    # print('range_list', range_list)
    # print("zoom_list:",len(zoom_list))
    # print("zoom_list:", zoom_list)
    for b in range(len(dd)):
        com_list = []
        for n in range(len(dd[b][1])):
            index = int(dd[b][1][n])
            # print("index: ",index)
            com_list.append(zoom_list[index])
            # print("com_list:",com_list)
            together = itertools.combinations(com_list, 2)
        list_b = list(together)
        # print("list_b:",list_b)

        # print(list_b)
        if list_b != []:

            for l in range(len(list_b)):
                # emmmm = list_b[l][0] & list_b[l][1]
                for d in range(len(zoom_list)):
                    if list_b[l][0] == zoom_list[d]:
                        priority1 = priority_list[d]
                    if list_b[l][1] == zoom_list[d]:
                        priority2 = priority_list[d]
                # print("dd[b]:",dd[b])
                # print("list_b[l][0]:",list_b[l][0])
                # print("list_b[l][1]:", list_b[l][1])
                # a1 = list_b[l][0].lower
                # b1 = list_b[l][0].upper
                # c1 = list_b[l][1].lower
                # d1 = list_b[l][1].upper
                a1 = list_b[l][0][0][0]
                b1 = list_b[l][0][1][0]
                c1 = list_b[l][1][0][0]
                d1 = list_b[l][1][1][0]

                len1 = a1.split('.')
                len2 = b1.split('.')
                len3 = c1.split('.')
                len4 = d1.split('.')
                sort_list = []
                # a,c 比较
                if len(len1) <= len(len3):
                    aclen = len(len1)
                else:
                    aclen = len(len3)
                try:
                    ac = "a = c"
                    for m in range(aclen):
                        if len(len1[m]) > len(len3[m]):
                            i = len(len1[m]) - len(len3[m])
                            for e in range(i):
                                len3[m] = "0" + len3[m]
                            if len1[m] > len3[m]:
                                ac = "a > c"
                                raise getoutofloop()
                        elif len(len1[m]) < len(len3[m]):
                            i = len(len3[m]) - len(len1[m])
                            for e in range(i):
                                len1[m] = "0" + len1[m]
                            if len1[m] < len3[m]:
                                ac = "a < c"
                                raise getoutofloop()
                        elif len(len1[m]) == len(len3[m]):
                            if len1[m] < len3[m]:
                                ac = "a < c"
                                raise getoutofloop()
                            elif len1[m] > len3[m]:
                                ac = "a > c"
                                raise getoutofloop()
                    sort_list.append(ac)
                except getoutofloop:
                    sort_list.append(ac)
                    pass
                # a, d比较
                if len(len1) <= len(len4):
                    adlen = len(len1)
                else:
                    adlen = len(len4)
                try:
                    ad = "a = d"
                    for m in range(adlen):
                        if len(len1[m]) > len(len4[m]):
                            i = len(len1[m]) - len(len4[m])
                            for e in range(i):
                                len4[m] = "0" + len4[m]
                            if len1[m] > len4[m]:
                                ad = "a > d"
                                raise getoutofloop()
                        elif len(len1[m]) < len(len4[m]):
                            i = len(len4[m]) - len(len1[m])
                            for e in range(i):
                                len1[m] = "0" + len1[m]
                            if len1[m] < len4[m]:
                                ad = "a < d"
                                raise getoutofloop()
                        elif len(len1[m]) == len(len4[m]):
                            if len1[m] < len4[m]:
                                ad = "a < d"
                                raise getoutofloop()
                            elif len1[m] > len4[m]:
                                ad = "a > d"
                                raise getoutofloop()
                    sort_list.append(ad)
                except getoutofloop:
                    sort_list.append(ad)
                    pass
                # b, c比较
                if len(len2) <= len(len3):
                    bclen = len(len2)
                else:
                    bclen = len(len3)
                try:
                    bc = "b = c"
                    for m in range(bclen):
                        if len(len2[m]) > len(len3[m]):
                            i = len(len2[m]) - len(len3[m])
                            for e in range(i):
                                len3[m] = "0" + len3[m]
                            if len2[m] > len3[m]:
                                bc = "b > c"
                                raise getoutofloop()
                        elif len(len2[m]) < len(len3[m]):
                            i = len(len3[m]) - len(len2[m])
                            for e in range(i):
                                len2[m] = "0" + len2[m]
                            if len2[m] < len3[m]:
                                bc = "b < c"
                                raise getoutofloop()
                        elif len(len2[m]) == len(len3[m]):
                            if len2[m] < len3[m]:
                                bc = "b < c"
                                raise getoutofloop()
                            elif len2[m] > len3[m]:
                                bc = "b > c"
                                raise getoutofloop()
                    sort_list.append(bc)
                except getoutofloop:
                    sort_list.append(bc)
                    pass
                # b, d比较
                if len(len2) <= len(len4):
                    bdlen = len(len2)
                else:
                    bdlen = len(len4)
                try:
                    bd = "b = d"
                    for m in range(bdlen):
                        if len(len2[m]) > len(len4[m]):
                            i = len(len2[m]) - len(len4[m])
                            for e in range(i):
                                len4[m] = "0" + len4[m]
                            if len2[m] > len4[m]:
                                bd = "b > d"
                                raise getoutofloop()
                        elif len(len2[m]) < len(len4[m]):
                            i = len(len4[m]) - len(len2[m])
                            for e in range(i):
                                len2[m] = "0" + len2[m]
                            if len2[m] < len4[m]:
                                bd = "b < d"
                                raise getoutofloop()
                        elif len(len2[m]) == len(len4[m]):
                            if len2[m] < len4[m]:
                                bd = "b < d"
                                raise getoutofloop()
                            elif len2[m] > len4[m]:
                                bd = "b > d"
                                raise getoutofloop()
                    sort_list.append(bd)
                except getoutofloop:
                    sort_list.append(bd)
                    pass
                type=""
                if "a > d" in sort_list or "b < c" in sort_list:
                    type="1"
                elif priority1 <= priority2 and "b = d" in sort_list and list_b[l][0][1][1]=="closed"  and list_b[l][1][1][1]=="open":
                    type = "2"
                elif priority1 > priority2 and "b = d" in sort_list and list_b[l][0][1][1]=="open" and list_b[l][1][1][1]=="closed":
                    type="3"
                elif "b = c" in sort_list and list_b[l][0][1][1]=="open" and list_b[l][1][0][1]=="closed":
                    type = "4"
                elif "b = c" in sort_list and list_b[l][0][1][1] =="closed" and list_b[l][1][0][1]=="open":
                    type = "5"
                elif "a = d" in sort_list and list_b[l][0][0][1]=="open" and list_b[l][1][1][1]=="closed":
                    type = "6"
                elif "a = d" in sort_list and list_b[l][0][0][1]=="closed" and list_b[l][1][1][1]=="open":
                    type = "7"
                elif priority1 < priority2 and "b > d" in sort_list:
                    list_b10 = str(list_b[l][0])
                    list_b11 = str(list_b[l][1])
                    c_node_name = list(dd[b])[0]
                    l_version=find_elder_version_updatetime(c_node_name,list_b[l][1][1][0],update_time)
                    news_version=find_fileversion_updatetime(c_node_name,update_time)
                    if l_version!=news_version:
                        type = "8"
                    # type = "8"
                elif priority1 > priority2 and "b < d" in sort_list:
                    list_b10 = str(list_b[l][0])
                    list_b11 = str(list_b[l][1])
                    c_node_name = list(dd[b])[0]
                    l_version = find_elder_version_updatetime(c_node_name, list_b[l][0][1][0],update_time)
                    news_version = find_fileversion_updatetime(c_node_name,update_time)
                    if l_version!=news_version:
                        type = "9"
                    # type = "9"
                if type!="":
                    # print("****************************************************************************************************")
                    # print("type:",type)
                    # conflict_node_name = list(dd[b])[0]
                    # list_b10 = str(list_b[l][0])
                    # list_b11 = str(list_b[l][1])
                    # print("list_b10:",list_b10)
                    # print("list_b11:", list_b11)
                    # print("发现冲突:", " 首节点:", first_node_name, " 首节点版本:", fileversion, " 冲突节点:", list(dd[b])[0])
                    confilct_status=1
                    confilct_node=str(list(dd[b])[0])
                    # write_db(first_node_name, fileversion, conflict_node_name, "type "+type, list_b10, list_b11)

    return confilct_status,confilct_node


#查询小于更新时间的最新版本
def find_fileversion_updatetime(filename,update_time):
    sql_1 = "SELECT version FROM pypi_info_version_all " \
            "where update_time<='%s' and file_name='%s' ORDER BY update_time DESC " % (update_time, filename)
    temp_version = ""
    with LOCK:
        try:
            db2 = POOL_validity.connection()
            # 执行sql语句
            selectUpdate_cursor = db2.cursor()
            selectUpdate_cursor.execute(sql_1)
            datas = selectUpdate_cursor.fetchone()  # 获取所有的数据
            if datas is not None:
                temp_version=datas[0]
        except Exception as e:
            print("find_fileversion_updatetime error",e)
        finally:
            db2.close()
    return temp_version

# 比较两个版本大小，返回较新的版本
def find_newestversion(version1,version2):
    v1_list = version1.split('.')
    v2_list = version2.split('.')
    if len(v1_list) < len(v2_list):
        length = len(v1_list)
    else:
        length = len(v2_list)
    status=0
    try:
        for m in range(length):
            if len(v1_list[m]) > len(v2_list[m]):
                i1 = len(v1_list[m]) - len(v2_list[m])
                for e1 in range(i1):
                    v2_list[m] = "0" + v2_list[m]
            if len(v2_list[m]) < len(v2_list[m]):
                i2 = len(v2_list[m]) - len(v1_list[m])
                for e2 in range(i2):
                    v1_list[m] = "0" + v1_list[m]
            if v1_list[m] < v2_list[m]:
                break
            if v1_list[m] > v2_list[m]:
                status=1
                raise getoutofloop()
    except getoutofloop:
        pass
    if status==0:
        return version2
    else:
        return version1

# 查询小于当前版本及更新时间的最新版本
def find_elder_version_updatetime(filename,fileversion,update_time):

    sql_v = "SELECT version FROM pypi_info_version_all " \
            "where update_time<='%s' and file_name='%s' ORDER BY update_time DESC " % (update_time, filename)
    temp_version=""
    with LOCK:
        try:
            db3 = POOL_validity.connection()
            # 执行sql语句
            selectversion_cursor = db3.cursor()
            selectversion_cursor.execute(sql_v)
            datas = selectversion_cursor.fetchall()  # 获取所有的数据
            # selectversion_cursor.close()
            if datas is not None:
                try:
                    for data in datas:
                        version=data[0]
                        if fileversion==find_newestversion(version,fileversion):
                            temp_version=version
                            raise getoutofloop()
                except getoutofloop:
                    pass
        except Exception as e:
            print("find_elder_version_updatetime error",e)
        finally:
            db3.close()
    return temp_version

if __name__ == '__main__':

    # file_url="D:/PycharmProjects/pypiMotivation/conflict_info_170101.txt"
    # host = "219.216.64.14"
    # host_local = "localhost"
    # user = "pypi"
    # password = "Aa12212748"
    # db_name_temp = "pypi_temp"
    # db_name_all = "db_name_all"
    # db_name_validity = "pypi_validity_evaluation"

    print(single_detect_conflict("coala-bears","0.10.0.dev20170101032144","2017-01-01 03:21:48"))
    # executor = ThreadPoolExecutor(40)
