import pymysql
import time
import detect_conflict
import multiprocessing
from concurrent.futures import ThreadPoolExecutor
class getoutofloop(Exception): pass
from DBUtils.PooledDB import PooledDB
from threading import RLock
import date_span
LOCK = RLock()

POOL_validity = PooledDB(
    creator=pymysql,  # 使用链接数据库的模块
    maxconnections=None,  # 连接池允许的最大连接数，0和None表示没有限制
    mincached=10,  # 初始化时，连接池至少创建的空闲的连接，0表示不创建
    maxcached=0,  # 连接池空闲的最多连接数，0和None表示没有限制
    maxshared=0,
    # 连接池中最多共享的连接数量，0和None表示全部共享，ps:其实并没有什么用，因为pymsql和MySQLDB等模块中的threadsafety都为1，所有值无论设置多少，_maxcahed永远为0，所以永远是所有链接共享
    blocking=True,  # 链接池中如果没有可用共享连接后，是否阻塞等待，True表示等待，False表示不等待然后报错
    setsession=[],  # 开始会话前执行的命令列表
    ping=0,  # ping Mysql 服务端，检查服务是否可用
    host='rm-j6cgph88etye1rs2xyo.mysql.rds.aliyuncs.com',
    port=3306,
    user='pypi',
    password='Aa12212748',
    database='pypi_validity_evaluation',
    charset='utf8'
 )

#
# POOL_temp = PooledDB(
#      creator = pymysql, #使用链接数据库的模块
#      maxconnections = None,  #连接池允许的最大连接数，0和None表示没有限制
#      mincached = 10, #初始化时，连接池至少创建的空闲的连接，0表示不创建
#      maxcached = 0, #连接池空闲的最多连接数，0和None表示没有限制
#      maxshared = 0, #连接池中最多共享的连接数量，0和None表示全部共享，ps:其实并没有什么用，因为pymsql和MySQLDB等模块中的threadsafety都为1，所有值无论设置多少，_maxcahed永远为0，所以永远是所有链接共享
#      blocking = True, #链接池中如果没有可用共享连接后，是否阻塞等待，True表示等待，False表示不等待然后报错
#      setsession = [],#开始会话前执行的命令列表
#      ping = 0,#ping Mysql 服务端，检查服务是否可用
#      host = '219.216.64.249',
#      port = 3306,
#      user = 'pypi',
#      password = 'Aa12212748',
#      database = 'pypi_temp',
#      charset = 'utf8'
#  )

#获取每个release及更新时间
def get_release():
    sql_01 = "SELECT file_name,version,update_time,is_potential_conflict FROM detect_info_date01_new where is_potential_conflict=1 "
    try:
        db = POOL_validity.connection()
        # 执行sql语句
        allversionname = db.cursor()
        allversionname.execute(sql_01)
        pypidatas = allversionname.fetchall()  # 获取所有的数据
        allversionname.close()
    except:
        print("allversionname()  dberror")
    finally:
        db.close()
    total_num=0
    # pypi_pool = multiprocessing.Pool()
    for pypidata in pypidatas:
         file_name = pypidata[0]
         version = pypidata[1]
         update_time = pypidata[2]
         # print(file_name,version,update_time)

         requirement_list=get_requirement(file_name,version)
         if requirement_list is not None:
             # print("requirementdatalist:",requirementdatalist)
             for r in requirement_list:
                 if r[0] is not None and r[0] != "" and r[1] is not None and r[1] != "" and "==" in r[3]:
                     requirement = r[0]
                     requirement_version = r[1]
                     requirement_version_status = r[2]
                     if requirement_version_status == 1 or requirement_version_status == "1":
                          total_num=total_num+1
                          print(file_name, version, requirement, requirement_version, requirement_version_status,update_time)
                          insert_re(file_name, version, requirement, requirement_version, requirement_version_status,update_time)

    print("total_num:",total_num)

def insert_re(file_name, version, requirement, requirement_version, requirement_version_status,update_time):
    sql_insert = "INSERT INTO forecast03_date01_new (package_name, package_version,requirement_name," \
                 "requirement_version,requirement_version_status,update_time) VALUES ('%s','%s','%s','%s','%s','%s')" % (
    file_name, version, requirement, requirement_version, requirement_version_status,update_time)
    with LOCK:
        try:
            # host = "localhost"
            # user = "pypi"
            # password = "Aa12212748"
            # db_name = "pypi_temp"

            db_insert = POOL_validity.connection()
            cursor_insert = db_insert.cursor()
            # 执行sql语句
            cursor_insert.execute(sql_insert)
            # 执行sql语句
            db_insert.commit()
            cursor_insert.close()
            # print("INSERT:", file_name, "FINISHED")
            # db_insert.close()
        except:
            print("INSERT pypi_info error")
            # 发生错误时回滚
            db_insert.rollback()
        finally:
            db_insert.close()

# 获取依赖
def get_requirement(package_name, package_version):
    with LOCK:
        sql2 = "select DISTINCT requirement,requirement_version,requirement_version_status,version_range from package_info where  package_name='%s' and package_version='%s'" % (package_name,package_version)
        get_requirement_datas=[]
        try:
            package_info_conn = POOL_validity.connection()
            package_info_cursor = package_info_conn.cursor()
            package_info_cursor.execute(sql2)
            get_requirement_datas = package_info_cursor.fetchall()
        except Exception as e:
            print("package_info db error",e)
        finally:
            package_info_conn.close()
    datalist=[]
    for u in get_requirement_datas:
        datalist.append(list(u))
    return datalist

#执行预测3
def do_forecast_type03():
    executor = ThreadPoolExecutor(20)
    sql = "SELECT package_name, package_version,requirement_name, requirement_version, requirement_version_status,update_time FROM forecast03_date01_new "
    temp_forecast_datas=""
    with LOCK:
        try:
            db = POOL_validity.connection()
            # 执行sql语句
            allversionname = db.cursor()
            allversionname.execute(sql)
            temp_forecast_datas = allversionname.fetchall()  # 获取所有的数据
            # allversionname.close()
        except Exception as e:
            print("get_all_newversion()  dberror",e)
        finally:
            db.close()
    print("total_num:",len(temp_forecast_datas))
    num=0
    if temp_forecast_datas is not None:
        for i in temp_forecast_datas:
            num=num+1
            executor.submit(do_detect,i, num)
            # do_detect(i, num)
            # file_name = i[0]
            # file_version = i[1]
            # requirement = i[2]
            # requirement_version = i[3]
            # update_time=i[5]
            # print("file_name: ",file_name," requirement: ",requirement," num: ",num)
            # influence_list=[]
            # nodelist1 = get_renodelist(file_name,file_version)
            # nodelist2 = get_renodelist(requirement, requirement_version)
            # if nodelist1!=[] and nodelist2!=[]:
            #      for l1 in nodelist1:
            #           for l2 in nodelist2:
            #                if l1[0]==l2[0] and l1[1]==l2[1]:
            #                     name_version=str(l1[0])+"-"+str(l1[1])
            #                     influence_list.append(name_version)
            #
            # if influence_list!=[]:
            #      print("*********************************************************************************")
            #      print("预测3: 节点:", file_name, " 节点版本:", file_version, " 依赖节点:", requirement, " 依赖节点版本:",
            #            requirement_version," 发布时间:",update_time)
            #      print("下游节点:", influence_list)
            #
            #      with open(file_url_type03, 'a', encoding='utf-8') as f:
            #           f.write(
            #                "*****************************************************************************************************" + "\n")
            #           # f.write("list_b[l][0]:" + list_b10 + "list_b[l][1]:" + list_b11 + "\n")
            #           f.write("发现预测3潜在冲突:" + " 节点:" + file_name + " 节点版本:" + file_version + " 依赖节点:" + requirement + " 依赖节点版本:" + requirement_version +" 发布时间:"+str(update_time)+ "\n")
            #           f.write("下游节点:" + str(influence_list) + "\n")

            # print(nodelist2)

def do_detect(i,num):
    num = num + 1
    file_name = i[0]
    file_version = i[1]
    requirement = i[2]
    requirement_version = i[3]
    update_time = i[5]
    print("Detecting Project: ", file_name, " Version No: ", file_version, "Last update date:", update_time," The library version being restricted:", requirement, requirement_version)
    # print("file_name: ", file_name, " requirement: ", requirement, " num: ", num)
    influence_list = []
    nodelist1 = get_renodelist(file_name, file_version)
    nodelist2 = get_renodelist(requirement, requirement_version)
    if nodelist1 != [] and nodelist2 != []:
        for l1 in nodelist1:
            for l2 in nodelist2:
                if l1[0] == l2[0] and l1[1] == l2[1]:
                    name_version = str(l1[0]) + "-" + str(l1[1])
                    influence_list.append(name_version)

    if influence_list != [] and date_span.check_date_forecast03(file_name,file_version,requirement,'201701_06Type_1')==1:
        print("*********************************************************************************")
        print("Finding out Potential DC issue(Type 1) Project:", file_name, " Version No:", file_version, " The library version being restricted:", requirement, requirement_version, " Last update date:", update_time)
        print("Downstream projects:", influence_list)
        print("*********************************************************************************")

        Type_1_url = "C://20170101-20170630//DC_issue_Type_1.txt"
        cdate = date_span.get_date_forecast03(file_name, file_version,requirement, '201701_06Type_1')

        lt = date_span.get_lasting_time(file_name, '201701_06Type_1')
        # print(ctype,cdate)
        if str(lt) != '-1':
            date_span.insert_status_forecast03(file_name, file_version,requirement, '201701_06Type_1')
            with open(Type_1_url, 'a', encoding='utf-8') as f:
                f.write(
                    "*****************************************************************************************************" + "\n")
                f.write("Project:" + file_name + "\n")
                f.write("Version number (containing DC issue):" + str(file_version) + "\n")
                f.write("The library version being restricted:" + str(requirement) +str(requirement_version)+ "\n")
                f.write("Date of DC issue arising:" + str(cdate[3]) + "\n")
                f.write("Downstream projects:" + str(influence_list) + "\n")
                f.write("Date of DC issue being resolved:" + str(cdate[4]) + "\n")
                f.write("Lasting time:" + str(cdate[5]) + "\n")
        elif str(lt) == '-1':
            date_span.insert_status_forecast03(file_name,file_version,requirement, '201701_06Type_1')
            with open(Type_1_url, 'a', encoding='utf-8') as f:
                f.write(
                    "*****************************************************************************************************" + "\n")
                f.write("Project:" + file_name + "\n")
                f.write("Version number (containing DC issue):" + str(file_version) + "\n")
                f.write("The library version being restricted:" + str(requirement) + str(requirement_version) + "\n")
                f.write("Date of DC issue arising:" + str(cdate[3]) + "\n")
                f.write("Downstream projects:" + str(influence_list) + "\n")
                f.write("Lasting time:" + "Not being resolved."+ "\n")
        # with open(file_url_type03, 'a', encoding='utf-8') as f:
        #     f.write(
        #         "*****************************************************************************************************" + "\n")
        #     # f.write("list_b[l][0]:" + list_b10 + "list_b[l][1]:" + list_b11 + "\n")
        #     f.write(
        #         "发现预测3潜在冲突:" + " 节点:" + file_name + " 节点版本:" + file_version + " 依赖节点:" + requirement + " 依赖节点版本:" + requirement_version + " 发布时间:" + str(
        #             update_time) + "\n")
        #     f.write("下游节点:" + str(influence_list) + "\n")




def get_renodelist(filename,version):
     sql2 = "select DISTINCT package_name,package_version,requirement_version,requirement_version_status from package_info where  requirement='%s'" % (filename)
     # get_requirement_datas = []
     nodelist=[]
     with LOCK:
          try:
               package_info_conn = POOL_validity.connection()
               package_info_cursor = package_info_conn.cursor()
               package_info_cursor.execute(sql2)
               get_requirement_datas = package_info_cursor.fetchall()
          except Exception as e:
               print("package_info db error", e)
          finally:
               package_info_conn.close()
     if get_requirement_datas is not None:
          for get_requirement_data in get_requirement_datas:
               temp_list=[]
               package_name=get_requirement_data[0]
               package_version=get_requirement_data[1]
               requirement_version=get_requirement_data[2]
               requirement_version_status=get_requirement_data[3]


               if requirement_version_status==0 or requirement_version_status=="0":
                    if requirement_version is None or requirement_version=="":
                         temp_list.append(package_name)
                         temp_list.append(package_version)
               elif requirement_version_status==1 or requirement_version_status=="1":
                    if requirement_version==version:
                         temp_list.append(package_name)
                         temp_list.append(package_version)
               elif  requirement_version_status==2 or requirement_version_status=="2":
                    if requirement_version==find_newestversion(requirement_version, version):
                         temp_list.append(package_name)
                         temp_list.append(package_version)
               if temp_list!=[]:
                    nodelist.append(temp_list)
     return nodelist


# 比较两个版本大小，返回较新的版本
def find_newestversion(version1, version2):
     v1_list = version1.split('.')
     v2_list = version2.split('.')
     if len(v1_list) < len(v2_list):
          length = len(v1_list)
     else:
          length = len(v2_list)
     status = 0
     try:
          for m in range(length):
               if len(v1_list[m]) > len(v2_list[m]):
                    i1 = len(v1_list[m]) - len(v2_list[m])
                    for e1 in range(i1):
                         v2_list[m] = "0" + v2_list[m]
               if len(v2_list[m]) < len(v2_list[m]):
                    i2 = len(v2_list[m]) - len(v1_list[m])
                    for e2 in range(i2):
                         v1_list[m] = "0" + v1_list[m]
               if v1_list[m] < v2_list[m]:
                    break
               if v1_list[m] > v2_list[m]:
                    status = 1
                    raise getoutofloop()
     except getoutofloop:
          pass
     if status == 0:
          return version2
     else:
          return version1


# def write_file(file_name, version):
#     cdate=date_span.get_date(file_name,version,ctype)
#     date_span.insert_status(file_name, version,ctype)
#     print(ctype,cdate)
#     with open(Pattern_A_url, 'a', encoding='utf-8') as f:
#         f.write("*****************************************************************************************************" + "\n")
#         f.write("Project:" + file_name +"\n")
#         f.write("Conflicting library:"+ str(cdate[2]) + "\n")
#         f.write("Version number (containing DC issue):" + str(version) + "\n")
#         f.write("Date of DC issue arising:" +str(cdate[3])+ "\n")
#         f.write("Date of DC issue being resolved:" + str(cdate[4]) + "\n")
#         f.write("Lasting time:" + str(cdate[5]) + "\n")

if __name__ == '__main__':
     # file_url_type03="D://lizhenming//PycharmProjects//pypiValidityEvaluation06/validity_forecast_type03_new.txt"


     # executor = ThreadPoolExecutor(20)

     # get_release()

     do_forecast_type03()
