import pymysql
import re
from concurrent.futures import ThreadPoolExecutor
class getoutofloop(Exception): pass
import datetime
import itertools
import os
from collections import defaultdict
import requests
from requests.exceptions import RequestException
from DBUtils.PooledDB import PooledDB
from threading import RLock
LOCK = RLock()

POOL_temp = PooledDB(
     creator = pymysql, #使用链接数据库的模块
     maxconnections = None,  #连接池允许的最大连接数，0和None表示没有限制
     mincached = 10, #初始化时，连接池至少创建的空闲的连接，0表示不创建
     maxcached = 0, #连接池空闲的最多连接数，0和None表示没有限制
     maxshared = 0, #连接池中最多共享的连接数量，0和None表示全部共享，ps:其实并没有什么用，因为pymsql和MySQLDB等模块中的threadsafety都为1，所有值无论设置多少，_maxcahed永远为0，所以永远是所有链接共享
     blocking = True, #链接池中如果没有可用共享连接后，是否阻塞等待，True表示等待，False表示不等待然后报错
     setsession = [],#开始会话前执行的命令列表
     ping = 0,#ping Mysql 服务端，检查服务是否可用
     host = '219.216.64.249',
     port = 3306,
     user = 'pypi',
     password = 'Aa12212748',
     database = 'pypi_temp',
     charset = 'utf8'
 )

POOL_validity = PooledDB(
     creator = pymysql, #使用链接数据库的模块
     maxconnections = None,  #连接池允许的最大连接数，0和None表示没有限制
     mincached = 10, #初始化时，连接池至少创建的空闲的连接，0表示不创建
     maxcached = 0, #连接池空闲的最多连接数，0和None表示没有限制
     maxshared = 0, #连接池中最多共享的连接数量，0和None表示全部共享，ps:其实并没有什么用，因为pymsql和MySQLDB等模块中的threadsafety都为1，所有值无论设置多少，_maxcahed永远为0，所以永远是所有链接共享
     blocking = True, #链接池中如果没有可用共享连接后，是否阻塞等待，True表示等待，False表示不等待然后报错
     setsession = [],#开始会话前执行的命令列表
     ping = 0,#ping Mysql 服务端，检查服务是否可用
     host = '219.216.64.249',
     port = 3306,
     user = 'pypi',
     password = 'Aa12212748',
     database = 'pypi_validity_evaluation',
     charset = 'utf8'
 )



def single_detect_potential_conflict(filename,fileversion,update_time):
    print("start detect: ",filename,fileversion,update_time)
    if fileversion is None:
        fileversion=""
    list1 = []
    list1.append(filename)
    list1.append(fileversion)
    list1.append("")
    global check_list
    check_list = []
    check_list.append(list1)
    check_requirement(check_list,0,update_time)

    check_name=[]
    for c in check_list:
        check_name.append(c[0])
    print(check_name)

    set_lst = set(check_name)
    print(set_lst)
    if len(set_lst) == len(check_name):
        potential_conflict_status=0
        print('列表里的元素互不重复！')
    else:
        potential_conflict_status=1
        print('存在潜在冲突节点！', filename, fileversion)

    sql_detect = "update detect_info_date05_new set is_potential_conflict='%s' where file_name='%s' and version='%s'" \
                 % (potential_conflict_status, filename, fileversion)
    try:
        db_potential = POOL_validity.connection()
        # 执行sql语句
        cursor_write_versionname = db_potential.cursor()
        cursor_write_versionname.execute(sql_detect)
        db_potential.commit()
        cursor_write_versionname.close()
    except Exception as e:
        print("INSERT INTO potential_conflict_info dberror", e)
        # 发生错误时回滚
        db_potential.rollback()
    finally:
        db_potential.close()
    # print(check_list)



def get_requirement(package_name,package_version):

    sql2 = "select DISTINCT requirement,requirement_version,requirement_version_status,version_range from package_info where  package_name='%s' and package_version='%s'" % (package_name,package_version)
    get_requirement_datas=[]
    try:
        db = POOL_temp.connection()
        # 执行sql语句
        sql_version_cursor = db.cursor()
        sql_version_cursor.execute(sql2)
        get_requirement_datas = sql_version_cursor.fetchall()  # 获取所有的数据
        sql_version_cursor.close()
        db.close()
    except:
        print("db error")
    datalist=[]
    for u in get_requirement_datas:
        datalist.append(list(u))
    return datalist

def check_requirement(check_list,num,update_time):
    if num>5:
        return
    # print("check_list:", check_list)
    # print("num:", num)
    if check_list!=[] and len(check_list)>num:
        temp_nodelist=[]
        temp_nodelist=check_list[num]
        if temp_nodelist !=[]:
            package_name=temp_nodelist[0]
            package_version = temp_nodelist[1]
            version_range = temp_nodelist[2]
            datalist = get_requirement(package_name, package_version)
            if datalist != []:
                for p in datalist:
                    requirement=p[0]
                    requirement_version=p[1]
                    requirement_version_status=p[2]
                    version_range=p[3]
                    true_verion=""
                    if requirement_version_status == 1 or requirement_version_status == "1":
                        true_verion = p[1]
                    elif requirement_version_status == 2 or requirement_version_status == "2":
                        try:
                            for temp_check in check_list:
                                if temp_check[0]==requirement:
                                    if requirement_version==find_newestversion(requirement_version,temp_check[1]):
                                        true_verion=temp_check[1]
                                    else:
                                        true_verion=find_elder_version_updatetime(requirement,requirement_version,update_time)
                                    raise getoutofloop()
                        except getoutofloop:
                            pass
                        if true_verion=="":
                            true_verion=find_elder_version_updatetime(requirement,requirement_version,update_time)
                    elif requirement_version_status == 0 or requirement_version_status == "0":
                        try:
                            for temp_check in check_list:
                                # print("requirement:",requirement)
                                # print("temp_check:",temp_check)
                                if temp_check[0]==requirement:
                                    true_verion=temp_check[1]
                                    raise getoutofloop()
                        except getoutofloop:
                            pass
                        if true_verion == "":
                            true_verion = find_fileversion_updatetime(requirement,update_time)

                    t_list=[]
                    t_list.append(requirement)
                    t_list.append(true_verion)
                    t_list.append(version_range)
                    check_list.append(t_list)
        check_requirement(check_list,num+1,update_time)
    # else:
        # print("check_list",check_list)
        # return check_list


#查询小于更新时间的最新版本
def find_fileversion_updatetime(filename,update_time):
    sql_1 = "SELECT version FROM pypi_info_version_all " \
            "where update_time<='%s' and file_name='%s' ORDER BY update_time DESC " % (update_time, filename)
    temp_version = ""
    try:
        # print(sql_1)
        db_updatetime = POOL_temp.connection()
        # 执行sql语句
        selectUpdate_cursor = db_updatetime.cursor()
        selectUpdate_cursor.execute(sql_1)
        datas = selectUpdate_cursor.fetchone()  # 获取所有的数据
        selectUpdate_cursor.close()

        if datas is not None:
            temp_version=datas[0]
    except:
        print("find_fileversion_updatetime error")
    finally:
        db_updatetime.close()
    return temp_version

# 比较两个版本大小，返回较新的版本
def find_newestversion(version1,version2):
    v1_list = version1.split('.')
    v2_list = version2.split('.')
    if len(v1_list) < len(v2_list):
        length = len(v1_list)
    else:
        length = len(v2_list)
    status=0
    try:
        for m in range(length):
            if len(v1_list[m]) > len(v2_list[m]):
                i1 = len(v1_list[m]) - len(v2_list[m])
                for e1 in range(i1):
                    v2_list[m] = "0" + v2_list[m]
            if len(v2_list[m]) < len(v2_list[m]):
                i2 = len(v2_list[m]) - len(v1_list[m])
                for e2 in range(i2):
                    v1_list[m] = "0" + v1_list[m]
            if v1_list[m] < v2_list[m]:
                break
            if v1_list[m] > v2_list[m]:
                status=1
                raise getoutofloop()
    except getoutofloop:
        pass
    if status==0:
        return version2
    else:
        return version1

# 查询小于当前版本及更新时间的最新版本
def find_elder_version_updatetime(filename,fileversion,update_time):

    sql_v = "SELECT version FROM pypi_info_version_all " \
            "where update_time<='%s' and file_name='%s' ORDER BY update_time DESC " % (update_time, filename)
    temp_version=""
    try:
        db3 = POOL_temp.connection()
        # 执行sql语句
        selectversion_cursor = db3.cursor()
        selectversion_cursor.execute(sql_v)
        datas = selectversion_cursor.fetchall()  # 获取所有的数据
        selectversion_cursor.close()
        if datas is not None:
            try:
                for data in datas:
                    version=data[0]
                    if fileversion==find_newestversion(version,fileversion):
                        temp_version=version
                        raise getoutofloop()
            except getoutofloop:
                pass
    except:
        print("find_elder_version_updatetime error")
    finally:
        db3.close()
    return temp_version

def get_page(url):
    headers={'User-Agent':'Mozilla/5.0 (Windows NT 10.0;Win64;x64) AppleWebKit/537.36 (KHTML, likeGecko) Chrome/74.0.3729.157 Safari/537.36'}
    try:
        response = requests.get(url,headers=headers)
        if response.status_code == 200:
            return response.text
        return None
    except RequestException:
        return None
