import requests
from requests.exceptions import RequestException
from concurrent.futures import ThreadPoolExecutor, wait, ALL_COMPLETED
import re
import time
import urllib.request
import datetime
from bs4 import BeautifulSoup
import json
import urllib
from urllib.request import Request, urlopen
import pymysql

#获取全部项目GitHub链接及star数量


def get_page(url):
    headers={'User-Agent':'Mozilla/5.0 (Windows NT 10.0;Win64;x64) AppleWebKit/537.36 (KHTML, likeGecko) Chrome/74.0.3729.157 Safari/537.36'}
    try:
        response = requests.get(url,headers=headers)
        if response.status_code == 200:
            return response.text
        return None
    except RequestException:
        return None


def allfilename():
    response = urllib.request.urlopen("https://pypi.tuna.tsinghua.edu.cn/simple/")
    # response = urllib.request.urlopen("http://mirrors.aliyun.com/pypi/simple/")
    html = response.read()
    data = html.decode('utf-8')
    soup = BeautifulSoup(data, 'lxml')
    for item in soup.find_all("a"):
        file_name_db = item.string
        if file_name_db == None:
            continue
        else:
            executor.submit(do_allfilename,file_name_db)


def do_allfilename(file_name_db):
    db = pymysql.connect(host, user, password, db_name)
    now = datetime.datetime.now()
    now = now.strftime("%Y-%m-%d %H:%M:%S")
    sql_insert = "INSERT INTO pypi_info (file_name, insert_date) VALUES ('%s','%s')" % (file_name_db, now)
    try:
        cursor_insertpypi = db.cursor()
        # 执行sql语句
        cursor_insertpypi.execute(sql_insert)
        # 执行sql语句
        db.commit()
        cursor_insertpypi.close()
        # print("INSERT:", file_name_db, "FINISHED")

    except:
        print("INSERT pypi_info error")
        # 发生错误时回滚
        db.rollback()
    db.close()

#
def get_results(url):
    # 30ad34440e1bdc0016db7ae316c3d4a1d75d18c1
    # headers = {'User-Agent': 'Mozilla/5.0',
    #            'Content-Type': 'application/json',
    #            'Accept': 'application/json',
    #            'Authorization': ' token dfbf7e7199d5b32f7d5b5b0b0e57c856bb75782d'
    #            }

    headers = {'User-Agent': 'Mozilla/5.0',
               'Content-Type': 'application/json',
               'Accept': 'application/json',
               'Authorization': ' token 30ad34440e1bdc0016db7ae316c3d4a1d75d18c1'
               }
    req = Request(url, headers=headers)
    response = urlopen(req).read()
    result = json.loads(response.decode())
    return result
#
#
# def find_githubinfo():
#     num=0
#     for i in range(26):
#         for j in range(1, 11):
#             num=num+1
#             if num<=4000:
#                 print("num:",num)
#                 giturl = 'https://api.github.com/search/repositories?q=%s+language:python&page=%i&per_page=100' \
#                          % ( chr((i + ord('a'))), j)
#                 print(giturl)
#                 try:
#                     items = get_results(giturl)
#                     for item in items['items']:
#                         try:
#                             file_name = item['name']
#                             stargazers_count = item['stargazers_count']
#                             html_url = item['html_url']
#                             # print("file_name:",file_name)
#                             # print("stargazers_count",stargazers_count)
#                             # print("html_url", html_url)
#                             executor.submit(insert_githubinfo, file_name, stargazers_count, html_url)
#                             # insert_githubinfo(file_name, stargazers_count, html_url)
#                         except Exception:
#                             pass
#                 except Exception:
#                     print("get search error")
#                     # time.sleep(60)
#                     pass
#             else:
#                 num=0
#                 time.sleep(3600)
#                 continue

def find_githubinfo():
    # SQL 查询语句
    sql = "SELECT id,file_name FROM pypi_info where (github_url is null or github_url ='') and id >=287890"
    # sql = "SELECT id,file_name FROM pypi_info where github_url is null or github_url =''"
    try:
        db = pymysql.connect(host, user, password, db_name)
        # 执行sql语句
        allversionname = db.cursor()
        allversionname.execute(sql)
        pypidatas = allversionname.fetchall()  # 获取所有的数据
        allversionname.close()
        db.close()
    except:
        print("allversionname()  dberror")
    num=0
    print(len(pypidatas))
    for pypidata in pypidatas:
        fileid = pypidata[0]
        filename = pypidata[1]
        try:
            do_find_githubinfo(fileid,filename,num)
        except:
            print("find_githubinfo: ",filename,"error")
            pass
        num=num+1


def do_find_githubinfo(fileid,filename,num):

        url = 'https://pypi.org/project/' + filename + '/'
        date_html = get_page(url)
        # print("date_html:",date_html)
        pattern_github = re.findall( '<div class="github-repo-info hidden" data-url="(.*?)">.*?GitHub', date_html,re.S)
        github_api=""
        github_url = "not in github"
        stars = "not in github"
        if pattern_github != []:
            github_api = pattern_github[0]
        # print("github_api:",github_api)
        if github_api!="":
            try:
                items = get_results(github_api)
                if items is not None:
                    stars = items['stargazers_count']
                    github_url = items['html_url']
                time.sleep(1)
            except :
                # time.sleep(3601)
                pass
        print("***************************************************************")
        print("num:",num)
        print("filename:",filename)
        print("github_url:",github_url)
        print("stars:", stars)

        insert_githubinfo(fileid, stars, github_url)


def insert_githubinfo(fileid,stargazers_count,html_url):
    # sql_insert = "INSERT INTO pypi_info (github_url, stars) VALUES ('%s','%s') where file_name = '%s' " % (html_url, stargazers_count,file_name)
    sql_update = " update  pypi_info set  github_url = '%s' ,  stars = '%s' where id = '%s'" % (html_url, stargazers_count, fileid)
    db = pymysql.connect(host, user, password, db_name)
    try:
        cursor_insertpypi = db.cursor()
        # 执行sql语句
        cursor_insertpypi.execute(sql_update)
        # 执行sql语句
        db.commit()
        cursor_insertpypi.close()
        print("update:", fileid, "FINISHED")
    except:
        print("sql_update:", sql_update)
        print("update pypi_info error")
        # 发生错误时回滚
        db.rollback()
    db.close()



def main():

    find_githubinfo()
    # do_find_githubinfo("autocommand")

if __name__ == '__main__':

    #数据库配置文件
    # host = "localhost"
    host = "219.216.64.14"
    user = "pypi"
    password = "12345678"
    db_name = "pypi_validity_evaluation"
    #声明线程池
    executor = ThreadPoolExecutor(5)
    main()
