import requests
from requests.exceptions import RequestException
import re
# import project_spider
import time
import urllib.request
import datetime
from bs4 import BeautifulSoup
import json
import urllib
from urllib.request import Request, urlopen
import pymysql
from concurrent.futures import ThreadPoolExecutor

#获取全部release更新日期

def get_page(url):
    headers={'User-Agent':'Mozilla/5.0 (Windows NT 10.0;Win64;x64) AppleWebKit/537.36 (KHTML, likeGecko) Chrome/74.0.3729.157 Safari/537.36'}
    try:
        response = requests.get(url,headers=headers)
        if response.status_code == 200:
            return response.text
        return None
    except RequestException:
        return None

#查询文件名，版本及更新时间
def fileversion(filename):
    # print("filename:",filename)
    url = 'https://pypi.org/project/' + filename + '/#history'
    date_html = get_page(url)
    versions = []
    re_version = re.findall('<p class="release__version">(.*?)<.*?<time class="tooltipped tooltipped-s -js-relative-time" datetime="(.*?)"', date_html, re.S)
    for v in re_version:
        templist=[]
        templist.append(v[0].strip())
        timeArray = time.strptime(v[1], "%Y-%m-%dT%H:%M:%S+0000")
        timeStamp = int(time.mktime(timeArray))
        templist.append(timeStamp)
        versions.append(templist)
    # print(versions[0])
    return versions


#将符合要求的版本插入数据库
def insert_package_version(time_start,time_end):
    timeArray_start = time.strptime(time_start, "%Y-%m-%d %H:%M:%S")
    timeStamp_start = int(time.mktime(timeArray_start))
    timeArray_end = time.strptime(time_end, "%Y-%m-%d %H:%M:%S")
    timeStamp_end =  int(time.mktime(timeArray_end))
    print("timeStamp_start:",timeStamp_start)
    print("timeStamp_end:", timeStamp_end)

    sql1 = "select id , file_name from pypi_info where stars!='not in github' and stars>=500"
    try:
        db = pymysql.connect(host, user, password, db_name)
        # 执行sql语句
        sql1_cursor = db.cursor()
        sql1_cursor.execute(sql1)
        datas = sql1_cursor.fetchall()  # 获取所有的数据
        sql1_cursor.close()
        db.close()
    except:
        print("find_allnode_sql1()  dberror")
    # print("total num:",len(datas))
    data_num=0
    for data in datas:
        fid = data[0]
        filename = data[1]
        do_insert_package_version(fid, filename,timeStamp_start,timeStamp_end,data_num)
        data_num=data_num+1
def do_insert_package_version(fid,filename,timeStamp_start,timeStamp_end,data_num):
    print("data_num:",data_num)
    versions_info=""
    try:
        versions_info=fileversion(filename)
    except:
        print("find version error:", filename)
        pass
    if versions_info!="":
        for version_info in versions_info:
            version=version_info[0]
            date=version_info[1]
            #该版本更新日期是否在时间范围内
            if date>=timeStamp_start and date <=timeStamp_end:
                print("version:",version)
                print("date:",date)
                update_timeArray = time.localtime(date)
                update_time = time.strftime("%Y-%m-%d %H:%M:%S", update_timeArray)
                sql_count = "SELECT COUNT(*) FROM pypi_info_version WHERE file_name = '%s'and version = '%s'" % (filename,version)
                try:
                    db = pymysql.connect(host, user, password, db_name)
                    # 执行sql语句
                    cursor_count = db.cursor()
                    cursor_count.execute(sql_count)
                    nums = cursor_count.fetchone()
                    cursor_count.close()
                    num = nums[0]
                    if num == 0:
                        now = datetime.datetime.now()
                        now = now.strftime("%Y-%m-%d %H:%M:%S")
                        sql_insert = "INSERT INTO pypi_info_version (file_name, version,update_time,insert_time,f_id) VALUES ('%s','%s','%s','%s','%s')" % (filename,version,update_time,now,fid)
                        try:
                            cursor_insertpypi = db.cursor()
                            cursor_insertpypi.execute(sql_insert)
                            db.commit()
                            cursor_insertpypi.close()
                            print("INSERT:", filename, "FINISHED")
                        except:
                            print(sql_insert)
                            print("INSERT pypi_info error")
                            # 发生错误时回滚
                            db.rollback()
                    else:
                        print("该文件版本已存在：", filename)
                    db.close()
                except:
                    print("find_filename dberror")


def insert_all_package_version():
    sql1 = "select id , file_name from pypi_info "
    try:
        db = pymysql.connect(host, user, password, db_name)
        # 执行sql语句
        sql1_cursor = db.cursor()
        sql1_cursor.execute(sql1)
        datas = sql1_cursor.fetchall()  # 获取所有的数据
        sql1_cursor.close()
        db.close()
    except:
        print("find_allnode_sql1()  dberror")
    # print("total num:",len(datas))
    data_num = 0
    for data in datas:
        fid = data[0]
        filename = data[1]
        executor.submit(do_insert_all_package_version, fid, filename, data_num)
        # do_insert_all_package_version(fid, filename, data_num)
        data_num = data_num + 1

def do_insert_all_package_version(fid, filename, data_num):
    print("data_num:", data_num)
    versions_info = ""
    try:
        versions_info = fileversion(filename)
    except:
        print("find version error:", filename)
        pass
    if versions_info != "":
        for version_info in versions_info:
            version = version_info[0]
            date = version_info[1]
            # 该版本更新日期是否在时间范围内
            print("version:", version)
            print("date:", date)
            update_timeArray = time.localtime(date)
            update_time = time.strftime("%Y-%m-%d %H:%M:%S", update_timeArray)
            sql_count = "SELECT COUNT(*) FROM pypi_info_version_all WHERE file_name = '%s'and version = '%s'" % (filename, version)
            try:
                db = pymysql.connect(host, user, password, db_name)
                # 执行sql语句
                cursor_count = db.cursor()
                cursor_count.execute(sql_count)
                nums = cursor_count.fetchone()
                cursor_count.close()
                num = nums[0]
                if num == 0:
                    now = datetime.datetime.now()
                    now = now.strftime("%Y-%m-%d %H:%M:%S")
                    sql_insert = "INSERT INTO pypi_info_version_all (file_name, version,update_time,insert_time,f_id) VALUES ('%s','%s','%s','%s','%s')" % (
                    filename, version, update_time, now, fid)
                    try:
                        cursor_insertpypi = db.cursor()
                        cursor_insertpypi.execute(sql_insert)
                        db.commit()
                        cursor_insertpypi.close()
                        print("data_num:", data_num,"   INSERT:", filename, "FINISHED")
                    except:
                        print(sql_insert)
                        print("INSERT pypi_info error")
                        # 发生错误时回滚
                        db.rollback()
                        pass
                else:
                    print("该文件版本已存在：", filename)
                db.close()
            except:
                print("find_filename dberror")
                pass


if __name__ == '__main__':
    # 数据库配置文件
    host = "localhost"
    user = "pypi"
    password = "12345678"
    db_name = "pypi_validity_evaluation"
    # 时间戳转换为指定日期格式
    # timeArray = time.localtime(timeStamp)
    # otherStyleTime = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
    time_start="2018-01-01 0:0:0"
    time_end="2018-12-31 23:59:59"

    # 声明线程池
    executor = ThreadPoolExecutor(20)
    insert_all_package_version()
    # insert_package_version(time_start,time_end)


    # timeStamp_start: 1514736000
    # timeStamp_end: 1546271999
    # do_insert_package_version("1","elastic2-doc-manager",1514736000,1546271999)
