import requests
from requests.exceptions import RequestException
from concurrent.futures import ThreadPoolExecutor, wait, ALL_COMPLETED
import re
import time
import urllib.request
import datetime
from bs4 import BeautifulSoup
import json
import urllib
from urllib.request import Request, urlopen
import pymysql
import detect_potential_conflict
import os
import tarfile
import zipfile
class getoutofloop(Exception): pass
from DBUtils.PooledDB import PooledDB
from threading import RLock
LOCK = RLock()

POOL_temp = PooledDB(
     creator = pymysql, #使用链接数据库的模块
     maxconnections = None,  #连接池允许的最大连接数，0和None表示没有限制
     mincached = 10, #初始化时，连接池至少创建的空闲的连接，0表示不创建
     maxcached = 0, #连接池空闲的最多连接数，0和None表示没有限制
     maxshared = 0, #连接池中最多共享的连接数量，0和None表示全部共享，ps:其实并没有什么用，因为pymsql和MySQLDB等模块中的threadsafety都为1，所有值无论设置多少，_maxcahed永远为0，所以永远是所有链接共享
     blocking = True, #链接池中如果没有可用共享连接后，是否阻塞等待，True表示等待，False表示不等待然后报错
     setsession = [],#开始会话前执行的命令列表
     ping = 0,#ping Mysql 服务端，检查服务是否可用
     host = '219.216.64.249',
     port = 3306,
     user = 'pypi',
     password = 'Aa12212748',
     database = 'pypi_temp',
     charset = 'utf8'
 )

POOL_validity = PooledDB(
     creator = pymysql, #使用链接数据库的模块
     maxconnections = None,  #连接池允许的最大连接数，0和None表示没有限制
     mincached = 10, #初始化时，连接池至少创建的空闲的连接，0表示不创建
     maxcached = 0, #连接池空闲的最多连接数，0和None表示没有限制
     maxshared = 0, #连接池中最多共享的连接数量，0和None表示全部共享，ps:其实并没有什么用，因为pymsql和MySQLDB等模块中的threadsafety都为1，所有值无论设置多少，_maxcahed永远为0，所以永远是所有链接共享
     blocking = True, #链接池中如果没有可用共享连接后，是否阻塞等待，True表示等待，False表示不等待然后报错
     setsession = [],#开始会话前执行的命令列表
     ping = 0,#ping Mysql 服务端，检查服务是否可用
     host = '219.216.64.249',
     port = 3306,
     user = 'pypi',
     password = 'Aa12212748',
     database = 'pypi_validity_evaluation',
     charset = 'utf8'
 )


#获取stars>=30的项目名，并查询指定时间段release数量
def findversionnum():
    sql = "SELECT file_name FROM pypi_info where stars!='not in github' and stars>=0 and id<=345000 and id>=344500"
    try:
        db = pymysql.connect(host, user, password, db_name)
        # 执行sql语句
        allversionname = db.cursor()
        allversionname.execute(sql)
        pypidatas = allversionname.fetchall()  # 获取所有的数据
        allversionname.close()
        db.close()
    except:
        print("allversionname()  dberror")
    num = 0
    print(len(pypidatas))
    totle_num=0
    for pypidata in pypidatas:
        filename = pypidata[0]
        executor.submit(update_versionnum,filename)
        # insert_pypi_info_num(filename)
        # update_versionnum(filename)
        # print("filename:",filename)
        # executor.submit(update_versionnum, filename)

def insert_pypi_info_num(filename):
    with LOCK:
        sql_insert = "insert into pypi_info_num_new (file_name) value ('%s')" % (filename)
        try:
            db2 = POOL_validity.connection()
            cursor_insertpypi = db2.cursor()
            cursor_insertpypi.execute(sql_insert)
            db2.commit()
            # cursor_insertpypi.close()
        except:
            print(sql_insert)
            print("INSERT pypi_info error")
            # 发生错误时回滚
            db2.rollback()
            pass
        finally:
            db2.close()

def update_versionnum(filename):
    with LOCK:
        sql_count1 = "select count(*) from pypi_info_version_all " \
                     "where  update_time>'2019-01-01 0:0:0' and update_time<'2019-06-30 23:59:59' " \
                     "  and file_name='%s'" % (filename)
        try:
            # 执行sql语句
            db_count = POOL_validity.connection()
            cursor_find_versionname = db_count.cursor()
            cursor_find_versionname.execute(sql_count1)
            nums = cursor_find_versionname.fetchone()
            cursor_find_versionname.close()
            num = nums[0]

            sql7 = "update  pypi_info_num_new set num_data05='%s'WHERE " \
                   "file_name = '%s' " % (num,filename)
            try:
                # print(sql7)
                # 执行sql语句
                # db=pymysql.connect(host, user, password, db_name)
                cursor = db_count.cursor()
                cursor.execute(sql7)
                db_count.commit()
                cursor.close()
                print("update: ", filename, " count: ",num," FINISHED")
            except Exception as e1:
                print("insert count01 error",e1)
        except Exception as e2:
            print("select count01 error",e2)
        finally:
            db_count.close()

def insert_detect_info_date05():
    sql_num = "SELECT file_name FROM pypi_info_num_new where num_data05>=3 and id<35000"
    num = 0
    try:
        # print(sql2)
        db2 = pymysql.connect(host, user, password, db_name)
        # 执行sql语句
        num_data05_cursor = db2.cursor()
        num_data05_cursor.execute(sql_num)
        file_datas = num_data05_cursor.fetchall()  # 获取所有的数据
        num_data05_cursor.close()
        db2.close()
    except:
        print("num_data05()  dberror")
    for file_data in file_datas:
        num=num+1
        filename=file_data[0]
        executor.submit(do_insert_detect_info_date05, filename,num)
        # do_insert_detect_info_date05(filename,num)

def do_insert_detect_info_date05(filename,num):
    with LOCK:
        sql_version = "select file_name,version,update_time from pypi_info_version_all " \
                      "where  update_time>'2019-01-01 0:0:0' and update_time<'2019-06-30 23:59:59' " \
                      "  and file_name='%s'" % (filename)
        try:
            # 执行sql语句
            db_version = POOL_validity.connection()
            cursor_find_versionname = db_version.cursor()
            cursor_find_versionname.execute(sql_version)
            pypiversiondatas = cursor_find_versionname.fetchall()
            cursor_find_versionname.close()

            if pypiversiondatas is not None:
                for pypiversiondata in pypiversiondatas:

                    file_name = pypiversiondata[0]
                    version = pypiversiondata[1]
                    update_time = pypiversiondata[2]

                    sql_requirement_count = "select count(*) from package_info where  package_name='%s' and package_version='%s'" % (
                        file_name, version)
                    get_requirement_datas = []
                    try:
                        db_requirement_count = POOL_temp.connection()
                        # 执行sql语句
                        requirement_count_cursor = db_requirement_count.cursor()
                        requirement_count_cursor.execute(sql_requirement_count)
                        count_datas = requirement_count_cursor.fetchone()  # 获取所有的数据
                        requirement_count_cursor.close()

                    except:
                        print("db error")
                    finally:
                        db_requirement_count.close()
                    count_r = count_datas[0]
                    if count_r >= 3:
                        sql = "INSERT INTO detect_info_date05_new (file_name,version,update_time) " \
                              "VALUES ('%s','%s','%s')" % (file_name, version, update_time)
                        try:
                            # 执行sql语句
                            # print(sql)
                            cursor_write_versionname = db_version.cursor()
                            cursor_write_versionname.execute(sql)
                            db_version.commit()
                            cursor_write_versionname.close()
                            print("INSERT  filename:", filename, "  version:", version," count_r:",count_r," FINISHED ")
                        except:
                            print("write_versionname() dberror")
                            # 发生错误时回滚
                            db_version.rollback()
        except:
            print("select version error")
        finally:
            db_version.close()


#判断是否为潜在冲突节点
def is_potential_conflict():
    sql_detect_info = "SELECT file_name,version,update_time FROM detect_info_date05_new where id<15000 "
    num = 0
    try:
        # print(sql2)
        db_detect_info = pymysql.connect(host, user, password, db_name)
        # 执行sql语句
        detect_info_cursor = db_detect_info.cursor()
        detect_info_cursor.execute(sql_detect_info)
        detect_datas = detect_info_cursor.fetchall()  # 获取所有的数据
        detect_info_cursor.close()
        db_detect_info.close()
    except:
        print("num_data05()  dberror")
    for detect_data in detect_datas:
        filename=detect_data[0]
        version=detect_data[1]
        update_time=detect_data[2]
        # print(filename,version,update_time)
        detect_potential_conflict.single_detect_potential_conflict(filename,version,update_time)
        # executor.submit(detect_potential_conflict.single_detect_potential_conflict, filename,version,update_time)

if __name__ == '__main__':
    #数据库配置文件
    # host = "localhost"
    host = "219.216.64.249"
    user = "pypi"
    password = "Aa12212748"
    db_name = "pypi_validity_evaluation"
    # db_name_temp="pypi_temp"
    # path = 'D:\lizhenming\pypi_projects\pypifile_date05'
    # savepath = "D:\lizhenming\pypi_projects\pypiuncompress_date05"

    #声明线程池
    executor = ThreadPoolExecutor(20)
    # findversionnum()
    # insert_detect_info_date05()
    #insert_detect_info_date05()
    is_potential_conflict()