import pymysql
import time
import detect_conflict
import multiprocessing
from concurrent.futures import ThreadPoolExecutor
import re
class getoutofloop(Exception): pass
from DBUtils.PooledDB import PooledDB
from threading import RLock
LOCK = RLock()

POOL_validity = PooledDB(
     creator = pymysql, #使用链接数据库的模块
     maxconnections = None,  #连接池允许的最大连接数，0和None表示没有限制
     mincached = 10, #初始化时，连接池至少创建的空闲的连接，0表示不创建
     maxcached = 0, #连接池空闲的最多连接数，0和None表示没有限制
     maxshared = 0, #连接池中最多共享的连接数量，0和None表示全部共享，ps:其实并没有什么用，因为pymsql和MySQLDB等模块中的threadsafety都为1，所有值无论设置多少，_maxcahed永远为0，所以永远是所有链接共享
     blocking = True, #链接池中如果没有可用共享连接后，是否阻塞等待，True表示等待，False表示不等待然后报错
     setsession = [],#开始会话前执行的命令列表
     ping = 0,#ping Mysql 服务端，检查服务是否可用
     host = 'localhost',
     port = 3306,
     user = 'lzm',
     password = '12345678',
     database = 'pypi_validity_evaluation',
     charset = 'utf8'
 )

def readtext(url,e_type):
     f = open(url,encoding='utf-8')
     lines = f.readlines()
     project=""
     conflicting_library=""
     version=""
     arising_date=""
     resolved_date=""
     lasting_time=""
     # e_type=""
     for line in lines:
          # print(line)
          # line.replace('/n', '')
          line = line.strip('\n')
          tital=line.split(':')[0]
          pattern = line.split(':')[-1]
          pattern=pattern.replace(' ','')
          # print(tital)

          if tital=='Project':
               project=pattern
          elif tital=='Conflicting library':
               conflicting_library=pattern
          elif tital == 'Version number (containing DC issue)':
               version = pattern
          elif tital == 'Date of DC issue arising':
               arising_date = pattern
          elif tital == 'Date of DC issue being resolved':
               resolved_date = pattern
          elif tital == 'Lasting time':
               lasting_time = pattern
               print("*********************")
               print("project: ", project)
               print("conflicting_library: ", conflicting_library)
               print("version: ", version)
               print("arising_date: ", arising_date)
               print("resolved_date: ", resolved_date)
               print("lasting_time: ", lasting_time)
               print("*********************")
               insert(project,conflicting_library,version,arising_date,resolved_date,lasting_time,e_type)

               project = ""
               conflicting_library = ""
               version = ""
               arising_date = ""
               resolved_date = ""
               lasting_time = ""
          if 'Not being resolved' in line:
              lasting_time=-1
              print("*********************")
              print("project: ",project)
              print("conflicting_library: ",conflicting_library)
              print("version: ",version)
              print("arising_date: ",arising_date)
              print("resolved_date: ",resolved_date)
              print("lasting_time: ",lasting_time)
              print("*********************")
              insert(project, conflicting_library, version, arising_date, resolved_date, lasting_time, e_type)
              project = ""
              conflicting_library = ""
              version = ""
              arising_date = ""
              resolved_date = ""
              lasting_time = ""
          # project_pattern = re.search('Project: (.*?)',str(line), re.S)
          # print(project_pattern)
          # if project_pattern is not None and project_pattern!='':
          #      project_date = project_pattern.group(1)
          #      print(project_date)
     f.close()

def insert(project,conflicting_library,version,arising_date,resolved_date,lasting_time,e_type):
     sql_insert = "INSERT INTO evaluation_info (project,conflicting_library,version,arising_date,resolved_date,lasting_time,e_type) VALUES ('%s','%s','%s','%s','%s','%s','%s')" % (
                       project,conflicting_library,version,arising_date,resolved_date,lasting_time,e_type)
     with LOCK:
          try:
               # host = "localhost"
               # user = "pypi"
               # password = "12345678"
               # db_name = "pypi_temp"

               db_insert = POOL_validity.connection()
               cursor_insert = db_insert.cursor()
               # 执行sql语句
               cursor_insert.execute(sql_insert)
               # 执行sql语句
               db_insert.commit()
               cursor_insert.close()
               # print("INSERT:", file_name, "FINISHED")
               # db_insert.close()
          except:
               print("INSERT pypi_info error")
               # 发生错误时回滚
               db_insert.rollback()
          finally:
               db_insert.close()
# C:\Users\lizhenming\Desktop\Evaluation dataset\20170101-20170630

if __name__ == '__main__':
    # url = "C:\\Users\\lizhenming\\Desktop\\Evaluation dataset\\20190101-20190630\\Potential_DC_issue_Type_2.txt"
    # e_type = "201901_06Type_2"

    url="C:\\Users\\lizhenming\\Desktop\\Evaluation dataset\\20190101-20190630\\Potential_DC_issue_Type_1.txt"
    e_type = "201901_06Type_1"
    # url = "C:\\Users\\lizhenming\\Desktop\\Evaluation dataset\\20190101-20190630\\DC_issue_Pattern_A.txt"
    # e_type="201901_06Pattern_A"
    readtext(url,e_type)