import pymysql
import re
from concurrent.futures import ThreadPoolExecutor
class getoutofloop(Exception): pass
import datetime
import itertools
import os
from collections import defaultdict
import requests
from requests.exceptions import RequestException
from DBUtils.PooledDB import PooledDB
from threading import RLock
LOCK = RLock()


POOL_validity = PooledDB(
     creator = pymysql, #使用链接数据库的模块
     maxconnections = None,  #连接池允许的最大连接数，0和None表示没有限制
     mincached = 10, #初始化时，连接池至少创建的空闲的连接，0表示不创建
     maxcached = 0, #连接池空闲的最多连接数，0和None表示没有限制
     maxshared = 0, #连接池中最多共享的连接数量，0和None表示全部共享，ps:其实并没有什么用，因为pymsql和MySQLDB等模块中的threadsafety都为1，所有值无论设置多少，_maxcahed永远为0，所以永远是所有链接共享
     blocking = True, #链接池中如果没有可用共享连接后，是否阻塞等待，True表示等待，False表示不等待然后报错
     setsession = [],#开始会话前执行的命令列表
     ping = 0,#ping Mysql 服务端，检查服务是否可用
     host = 'localhost',
     port = 3306,
     user = 'lzm',
     password = '12345678',
     database = 'pypi_validity_evaluation',
     charset = 'utf8'
 )


def main():

    sql_01 = "SELECT file_name FROM pypi_info "
    temp_requirement = ''
    try:
        db = POOL_validity.connection()
        # 执行sql语句
        allversionname = db.cursor()
        allversionname.execute(sql_01)
        file_namedatas = allversionname.fetchall()  # 获取所有的数据
        allversionname.close()
        # datas = selectUpdate_cursor.fetchone()  # 获取所有的数据
        for file_namedata in file_namedatas:
            if file_namedata is not None:
                temp_requirement_list=[]
                filename = file_namedata[0]
                verison=find_newversion(filename)
                temp_requirement_list=find_requrement(filename,verison)
                print(filename,verison,temp_requirement_list)
                if temp_requirement_list==[]:
                    temp_requirement_list=''
                    insert(filename, temp_requirement_list)
                else:
                    for temp_requirement in temp_requirement_list:
                        # print(filename,verison,temp_requirement)
                        insert(filename, temp_requirement)

    except:
        print("allversionname()  dberror")
    finally:
        db.close()


def insert(filename,requirement):
    sql_insert = "INSERT INTO package_requirement (package_name, requirement) VALUES ('%s','%s')" % (filename, requirement)
    try:
        # host = "localhost"
        # user = "pypi"
        # password = "12345678"
        # db_name = "pypi_temp"

        db_insert = POOL_validity.connection()
        cursor_insert = db_insert.cursor()
        # 执行sql语句
        cursor_insert.execute(sql_insert)
        # 执行sql语句
        db_insert.commit()
        cursor_insert.close()
        # print("INSERT:", file_name, "FINISHED")
        # db_insert.close()
    except:
        print("INSERT pypi_info error")
        # 发生错误时回滚
        db_insert.rollback()
    finally:
        db_insert.close()

def find_requrement(package_name,package_version):
    sql_01 = "SELECT requirement FROM package_info where package_name='%s' and package_version='%s' " % (
    package_name, package_version)
    temp_requirement=[]
    try:
        db = POOL_validity.connection()
        # 执行sql语句
        allversionname = db.cursor()
        allversionname.execute(sql_01)
        pypidatas = allversionname.fetchall()  # 获取所有的数据
        allversionname.close()
        # datas = selectUpdate_cursor.fetchone()  # 获取所有的数据
        for pypidata in pypidatas:
            if pypidata is not None:
                temp_requirement.append(pypidata[0])
    except:
        print("allversionname()  dberror")
    finally:
        db.close()
    return temp_requirement


def find_newversion(filename):
    sql_1 = "SELECT version FROM pypi_info_version_all " \
            "where file_name='%s' ORDER BY update_time DESC " % (filename)
    temp_version = ""
    with LOCK:
        try:
            db2 = POOL_validity.connection()
            # 执行sql语句
            selectUpdate_cursor = db2.cursor()
            selectUpdate_cursor.execute(sql_1)
            datas = selectUpdate_cursor.fetchone()  # 获取所有的数据
            if datas is not None:
                temp_version = datas[0]
        except Exception as e:
            print("find_fileversion_updatetime error", e)
        finally:
            db2.close()
    return temp_version



if __name__ == '__main__':

    # file_url="D:/PycharmProjects/pypiMotivation/conflict_info_170101.txt"
    # host = "219.216.64.14"
    # host_local = "localhost"
    # user = "pypi"
    # password = "12345678"
    # db_name_temp = "pypi_temp"
    # db_name_all = "db_name_all"
    # db_name_validity = "pypi_validity_evaluation"
    main()
    # executor = ThreadPoolExecutor(40)
