import os

import pymysql
import time
import detect_conflict
import detect_forecast
import detect_forecast03_period3
import date_span
import get_metricsinfo
import multiprocessing
from concurrent.futures import ThreadPoolExecutor
from DBUtils.PooledDB import PooledDB
from threading import RLock
LOCK = RLock()



POOL_validity = PooledDB(
    creator=pymysql,  # 使用链接数据库的模块
    maxconnections=None,  # 连接池允许的最大连接数，0和None表示没有限制
    mincached=10,  # 初始化时，连接池至少创建的空闲的连接，0表示不创建
    maxcached=0,  # 连接池空闲的最多连接数，0和None表示没有限制
    maxshared=0,
    # 连接池中最多共享的连接数量，0和None表示全部共享，ps:其实并没有什么用，因为pymsql和MySQLDB等模块中的threadsafety都为1，所有值无论设置多少，_maxcahed永远为0，所以永远是所有链接共享
    blocking=True,  # 链接池中如果没有可用共享连接后，是否阻塞等待，True表示等待，False表示不等待然后报错
    setsession=[],  # 开始会话前执行的命令列表
    ping=0,  # ping Mysql 服务端，检查服务是否可用
    host='rm-j6cgph88etye1rs2xyo.mysql.rds.aliyuncs.com',
    port=3306,
    user='pypi',
    password='Aa12212748',
    database='pypi_validity_evaluation',
    charset='utf8'
 )



def daily_check(startdate,enddate):
    starttimeArray = time.strptime(startdate, "%Y-%m-%d %H:%M:%S")
    starttimeStamp = int(time.mktime(starttimeArray))

    endtimeArray = time.strptime(enddate, "%Y-%m-%d %H:%M:%S")
    endtimeStamp = int(time.mktime(endtimeArray))

    # print(endtimeStamp)
    dailytimeStamp=starttimeStamp
    while (1):
        releaselist = []
        if dailytimeStamp<=endtimeStamp:

            dailytimeArray = time.localtime(dailytimeStamp)
            daily_time = time.strftime("%Y-%m-%d %H:%M:%S", dailytimeArray)
            daily_date=time.strftime("%Y-%m-%d", dailytimeArray)
            y_dailytimeArray=time.localtime(dailytimeStamp-86400)
            y_daily_time = time.strftime("%Y-%m-%d %H:%M:%S", y_dailytimeArray)

            print("******************************************************************************")
            print(daily_time)
            releaselist=get_release(daily_time)
            for releaseinfo in releaselist:
                file_name = releaseinfo[0]
                fversion = releaseinfo[1]
                update_time = releaseinfo[2]
                print("Detecting Project: ",file_name," Version No: ",fversion,"Last update date:",update_time," Detection date:",daily_date)
                update_timeArray = time.strptime(str(update_time), "%Y-%m-%d %H:%M:%S")
                update_timeStamp = int(time.mktime(update_timeArray))
                if update_timeStamp>dailytimeStamp-86400:
                    local_conflict_status = 0
                    forecast_status = 0
                    try:
                        local_conflict_status = detect_conflict.single_detect_conflict(file_name, fversion, update_time)
                    except Exception as e:
                        # print("single_detect_conflict local", e)
                        pass
                    if local_conflict_status == 1:
                        # 插入数据库
                        insert_conflict_date(file_name, fversion, update_time)
                        if date_span.check_date(file_name, fversion,"201801_06Pattern_A")==1:
                            print("Finding out DC issue(Pattern A):", file_name, fversion, update_time)
                            write_file(file_name, fversion, "201801_06Pattern_A")
                        # 记录时间
                    else:
                        # 检测预测一
                        try:
                            forecast_status = detect_forecast.single_detect_forecast_type01(file_name, fversion,update_time)
                        except Exception as e:
                            # print("single_detect_forecast_type01", e)
                            pass
                        if forecast_status == 1:
                            # 插入数据库
                            insert_forecast_date(file_name, fversion, update_time)
                            if  date_span.check_date(file_name, fversion,"201801_06Type_2")==1:
                                print("Finding out Potential DC issue(Type 2):", file_name, fversion, update_time)
                                write_file(file_name, fversion, "201801_06Type_2")
                else:
                    try:
                        conflict_status = detect_conflict.single_detect_conflict(file_name, fversion, daily_time)
                        if conflict_status == 1:
                            insert_conflict_date(file_name, fversion, daily_time)
                            if date_span.check_date(file_name, fversion, "201801_06Pattern_A") == 1:
                                print("Finding out DC issue(Pattern A):", file_name, fversion, daily_time)
                                write_file(file_name, fversion, "201801_06Pattern_A")

                    except Exception as e:
                        # print("single_detect_conflict update", e)
                        pass
            date_span.check(dailytimeStamp,'201801_06Pattern_A','201801_06Type_2',Pattern_A_url,Type_2_url)
        else:
            break
        dailytimeStamp = dailytimeStamp + 86400

#获取每个release及更新时间
def get_release(dailytime):
    releaselist=[]
    sql_01 = "SELECT file_name,version,update_time,is_potential_conflict FROM detect_info_date03_new where is_potential_conflict=1 and cause_conflict_date is null and  update_time<='%s'"%(dailytime)
    try:
        db = POOL_validity.connection()
        # 执行sql语句
        allversionname = db.cursor()
        allversionname.execute(sql_01)
        pypidatas = allversionname.fetchall()  # 获取所有的数据
        allversionname.close()
    except:
        print("allversionname()  dberror")
    finally:
        db.close()
    total_num=0
    # pypi_pool = multiprocessing.Pool()
    for pypidata in pypidatas:
        templist=[]
        file_name=pypidata[0]
        fversion=pypidata[1]
        update_time=pypidata[2]
        templist.append(file_name)
        templist.append(fversion)
        templist.append(update_time)
        releaselist.append(templist)
        # all_date(file_name, version, str(update_time),total_num)
        # executor.submit(all_date,file_name, version, str(update_time),total_num)
        # pypi_pool.apply_async(all_date, args=(file_name, version, str(update_time),total_num,))
        total_num=total_num+1
    return releaselist
    # pypi_pool.close()
    # pypi_pool.join()


def all_date(file_name,version,update_time,total_num,ctype):
    # print(file_name,version,update_time,total_num)
    # # 86400
    # with LOCK:
    # print("total_num:",total_num)
    timeArray = time.strptime(update_time, "%Y-%m-%d %H:%M:%S")
    timeStamp = int(time.mktime(timeArray))


    timeArray_end = time.strptime(end_update_time, "%Y-%m-%d %H:%M:%S")
    timeStamp_end = int(time.mktime(timeArray_end))
    local_conflict_status=0
    forecast_status=0
    try:
        local_conflict_status = detect_conflict.single_detect_conflict(file_name, version, update_time)
    except Exception as e:
        print("single_detect_conflict error", e)
        pass
    if local_conflict_status==1 and date_span.check_date(file_name, version, update_time,ctype)==1:
        # 插入数据库

        # insert_conflict_date(file_name, version, update_time)
        print("Finding out DC issue(Pattern A):",file_name, version, update_time)
        #记录时间
    else:
        # 检测预测一
        try:
            forecast_status = detect_forecast.single_detect_forecast_type01(file_name, version, update_time)
        except Exception as e:
            print("single_detect_forecast_type01 ", e)
            pass
        if forecast_status == 1:
            # 插入数据库
            # insert_forecast_date(file_name, version, update_time)
            print("Finding out Potential DC issue(Type 2):", file_name, version, update_time)

        # 检测更新bug
        conflict_detectStamp = timeStamp
        conflict_status=0


        while (1):
            conflict_status = 0
            # 按天扫描是否冲突
            conflict_detectStamp = conflict_detectStamp + 86400*1
            detect_time = ""
            if conflict_detectStamp <= timeStamp_end:
                timeArray = time.localtime(conflict_detectStamp)
                detect_time = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
                try:
                    conflict_status = detect_conflict.single_detect_conflict(file_name, version, detect_time)
                    if conflict_status == 1:
                        insert_conflict_date(file_name, version, detect_time)
                        print("Finding out DC issue(Pattern A):", file_name, version, detect_time)
                        break;
                except Exception as e:
                    print(" while single_detect_conflict", e)
                    pass
            else:
                break
        # while (1):
        #     conflict_status = 0
        #     conflict_detectStamp = conflict_detectStamp + 86400
        #     detect_time = ""
        #     if conflict_detectStamp <= timeStamp_end:
        #         timeArray = time.localtime(conflict_detectStamp)
        #         detect_time = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
        #         try:
        #             conflict_status = detect_conflict_appointdate.single_detect_conflict(file_name, version, detect_time)
        #         except Exception as e:
        #             print(" while single_detect_conflict", e)
        #             pass
        #     else:
        #         break
        #     if conflict_status == 1:
        #         insert_conflict_date(file_name, version, detect_time)
        #         print("发现冲突（节点更新/预测一）:", file_name, version, detect_time)
        #         break;


        # # 检测预测一
        # while (1):
        #     forecast_status = 0
        #     detect_time = ""
        #     if forecast01_detectStamp <= timeStamp_end:
        #         timeArray = time.localtime(forecast01_detectStamp)
        #         detect_time = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
        #         try:
        #             forecast_status = detect_forecast.single_detect_forecast_type01(file_name, version, detect_time)
        #         except Exception as e:
        #             print(" while single_detect_conflict", e)
        #             pass
        #     else:
        #         break
        #     if forecast_status == 1:
        #         insert_forecast_date(file_name, version, detect_time)
        #         print("发现预测一:",file_name, version, detect_time)
        #         break;
        #     forecast01_detectStamp = forecast01_detectStamp + 86400
def insert_conflict_date(file_name, version, update_time):

    sql_conflict_date = "update detect_info_date03_new set cause_conflict_date= '%s' " \
                              " where file_name='%s' and version='%s'" % (update_time,file_name, version )
    with LOCK:
        try:
            # 执行sql语句
            # print(sql)
            db_conflict_date = POOL_validity.connection()
            cursor_conflict_date = db_conflict_date.cursor()
            cursor_conflict_date.execute(sql_conflict_date)
            db_conflict_date.commit()
        except:
            print("write_versionname() dberror")
            # 发生错误时回滚
            db_conflict_date.rollback()
        finally:
            db_conflict_date.close()

def insert_forecast_date(file_name, version, update_time):
    sql_forecast_date = "update detect_info_date03_new set cause_forecast_date= '%s' " \
                              " where file_name='%s' and version='%s'" % (update_time,file_name, version )
    with LOCK:
        try:
            # 执行sql语句
            # print(sql)
            db_forecast_date = POOL_validity.connection()
            cursor_forecast_date = db_forecast_date.cursor()
            cursor_forecast_date.execute(sql_forecast_date)
            db_forecast_date.commit()
        except:
            print("write_versionname() dberror")
            # 发生错误时回滚
            db_forecast_date.rollback()
        finally:
            db_forecast_date.close()

def write_file(file_name, version,ctype):

    if ctype=="201801_06Pattern_A":
        cdate=date_span.get_date(file_name,version,ctype)
        date_span.insert_status(file_name, version,ctype)
        with open(Pattern_A_url, 'a', encoding='utf-8') as f:
            f.write("*****************************************************************************************************" + "\n")
            f.write("Project:" + file_name +"\n")
            f.write("Conflicting library:"+ str(cdate[2]) + "\n")
            f.write("Version number (containing DC issue):" + str(version) + "\n")
            f.write("Date of DC issue arising:" +str(cdate[3])+ "\n")
            f.write("Date of DC issue being resolved:" + str(cdate[4]) + "\n")
            f.write("Lasting time:" + str(cdate[5]) + "\n")

    elif ctype=="201801_06Type_2":
        lt=date_span.get_lasting_time(file_name,ctype)
        # print(ctype,cdate)
        if str(lt)!='-1':
            cdate = date_span.get_date(file_name, version, ctype)
            date_span.insert_status(file_name, version,ctype)
            with open(Type_2_url,  'a', encoding='utf-8') as f:
                f.write("*****************************************************************************************************" + "\n")
                f.write("Project:" + file_name +"\n")
                f.write("Version number (containing DC issue):" + str(version) + "\n")
                f.write("Date of DC issue arising:" +str(cdate[3])+ "\n")
                f.write("Date of DC issue being resolved:" + str(cdate[4]) + "\n")
                f.write("Lasting time:" + str(cdate[5]) + "\n")
        elif str(lt)=='-1':
            date_span.insert_status(file_name,"0",ctype)
            with open(Type_2_url, 'a', encoding='utf-8') as f:
                f.write("*****************************************************************************************************" + "\n")
                f.write("Project:" + file_name +"\n")
                f.write("Not being resolved."+ "\n")

def main():
    isExists = os.path.exists(path)
    if not isExists:
        os.makedirs(path)
    date_span.update_start_date('201801_06')
    daily_check(startdate, enddate)
    detect_forecast03_period3.do_forecast_type03()
    get_metricsinfo.get_metrics('C:\\20180101-20180630\\Metrics.txt', '201801_06Pattern_A', '201801_06Type_1', '201801_06Type_2')
if __name__ == '__main__':
    # host = "localhost"
    # user = "pypi"
    # password = "Aa12212748"
    # db_name = "pypi_validity_evaluation"
    path="C://20180101-20180630"
    end_update_time="2018-06-30 23:59:59"
    startdate="2018-01-01 23:59:59"
    enddate="2018-06-30 23:59:59"
    Pattern_A_url = "C://20180101-20180630//DC_issue_Pattern_A.txt"
    Type_2_url = "C://20180101-20180630//DC_issue_Type_2.txt"
    # executor = ThreadPoolExecutor(40)
    main()

    # get_release()

    # get_release()
    # detect_forecast03.do_forecast_type03()
